<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task 30.10</title>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css">
</head>

<body onload="onPageLoading()">
    <div class="container">
        <h1 class="text-center">Login Form</h1>
        <form id="loginForm">
            <div class="group-control">
                <label for="inp-email">Email address</label>
                <input type="text" class="form-control" id="inp-email" placeholder="Enter Email" />
                <p style="color:gray">We'll never share your email with anyone else.</p>
            </div>
            <div class="group-control">
                <label for="inp-password">Password</label>
                <input type="password" class="form-control" id="inp-password" placeholder="Password" />
            </div>
            <div class="group-control">
                <button type="submit" class="btn btn-primary mt-4">Submit</button>
            </div>
        </form>
    </div>
</body>

</html>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_STATUS_CREATED = 201;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "https://62458c222cfed18817229118.mockapi.io/users";
    const gBASE_URL_CONTACTS = "https://62458c222cfed18817229118.mockapi.io/contacts";
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        "use strict";
        var frmLogin = document.getElementById("loginForm");
        frmLogin.addEventListener("submit", function (e) {
            e.preventDefault(); // Ngăn chặn submit mặc định
            console.log("Bạn đã submit form!");

            // Bước 0: Tạo đối tượng chứa dữ liệu thu thập
            var vObject = {
                email: "",
                password: ""
            }
            // Bươc 1: Thu thập dữ liệu
            getDataFromInput(vObject);
            console.log(vObject);
            // Bước 2: Kiểm tra dữ liệu thu thập
            var vCheck = validateData(vObject);
            console.log(vCheck);
            if (vCheck == true) {
                // Bước 3: Gọi API xử lý
                // create a request
                var vXmlHttpLogin = new XMLHttpRequest();
                callLoginAPI(vXmlHttpLogin, vObject);                
                vXmlHttpLogin.onreadystatechange =
                function () {
                    if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                        var vLoginInfo = vXmlHttpLogin.responseText;
                        console.log(vLoginInfo);
                        var vObjectResponse = JSON.parse(vLoginInfo);
                        // Bước 4: Hiển thị kết quả sau khi gọi API
                        displayData(vObjectResponse);
                    }
                }
            }

        })
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm hiển thị kết quả đăng nhập
    // Input là dữ liệu cần xử lý
    function displayData(paramData){
        "use strict";
        alert("Bạn đã đăng nhập thành công!");
    }
    // Hàm xử lý AJAX
    // Input là đối tượng Request và đối tượng dữ liệu
    function callLoginAPI(paramRequest, paramObject) {
        "use strict";
        paramRequest.open("GET", gBASE_URL + "?" + paramObject.toString(), true);
        paramRequest.send();
    }
    // Hàm kiểm tra email hợp lệ
    // Input là email cần kiểm tra
    // Ouput là true / false
    function validateEmail(email) {
        var re = /\S+@\S+\.\S+/;
        return re.test(email);
    }
    // Hàm kiểm tra dữ liệu thu thập
    // Input là đối tượng cần kiểm tra dữ liệu
    // Output là true / false
    function validateData(paramObject) {
        "use strict";
        var vEmail = paramObject.email.trim();
        var vPassword = paramObject.password.trim();
        var vResult = true;
        // Kiểm tra nhập rỗng
        if (vEmail == "") {
            vResult = false;
            alert("Bạn chưa nhập Email!");
        } else {
            // Kiểm tra email có hợp lệ theo định dạng
            if (validateEmail(vEmail) == false) {
                vResult = false;
                alert("Email không đúng định dạng!");
            }
        }
        if (vPassword == "") {
            vResult = false;
            alert("Bạn chưa nhập Password!");
        } else {
            var vLengthPass = vPassword.length;
            if (vLengthPass < 6) {
                vResult = false;
                alert("Password nhập vào nhỏ hơn 6 ký tự!");
            }
        }

        return vResult;
    }

    // Hàm thu thập dữ liệu
    // Input là đối tượng chứa dữ liệu cần thu thập
    function getDataFromInput(paramObject) {
        "use strict";
        var vEmail = document.getElementById("inp-email");
        paramObject.email = vEmail.value;
        var vPassword = document.getElementById("inp-password");
        paramObject.password = vPassword.value;
    }
</script>